import java.util.ArrayList;
import java.util.Scanner;

public class Course
{
	private String name;
	private int code;
	private int units;
	private Professor prof;
	private ArrayList<StudentRecord> studentList = new ArrayList<StudentRecord>();
	
	public Course(String name, int code, int units){
		this.name = name;
		this.code = code;
		this.units = units;
	}
	
	public void setProf(Professor p){
		prof = p;
		p.setLesson(this);
	}
	
	public void enroll(Student s){
		studentList.add(new StudentRecord(s));
	}
	
	public void assignGrades(){
		System.out.println("Give grades for course "+toString());
		Scanner input = new Scanner(System.in);
		for(StudentRecord sr: studentList){
			System.out.println("Give grade for student "+ sr.getStudent().getName() +":");
			double grade = input.nextDouble();
			sr.setGrade(grade);
			if (sr.passed()){
				sr.getStudent().addUnits(units);
			}
		}
	}
	
	public String toString(){
		return name + " " + code + "("+units + ")";
	}
	
	public void printInfo(){
		System.out.println("Course " + name +" " + code + "("+units + ")");
		//System.out.println("professor:" + prof);
		for (StudentRecord r: studentList){
			System.out.println(r);
		}
	}
}