import java.util.ArrayList;
import java.util.Scanner;

class Student
{
	private String name;
	private int AM;
	private int units;
	
	public Student(String name, int AM){
		this.name = name;
		this.AM = AM;
	}
	
	public String getName(){
		return name;
	}
	
	public String toString()
	{
		return name + "\tAM:" + AM +"\tUnits:" + units;
	}
	
	public void assignUnits(int units){
		this.units += units;
	}
}

class Professor
{
	private String name;
	private int AFM;
	private Course course;
	
	public Professor(String name, int AFM){
		this.name = name;
		this.AFM = AFM;
	}
	
	public String toString()
	{
		return name + "\tAFM:" + AFM;
	}
	
	public void assignCourse(Course c){
		course = c;
	}
}

class StudentRecord
{
	private Student student;
	private double grade;
	
	public StudentRecord(Student s){
		student = s;
	}
	
	public void assignGrade(double grade){
		this.grade = grade;
	}
	
	public Student getStudent(){
		return student;
	}
	
	public boolean pass(){
		if (grade >= 5){
			return true;
		}
		return false;
	}
	
	public String toString(){
		return student + " grade:" + grade;
	}
}

class Course
{
	private String name;
	private int units;
	private ArrayList<StudentRecord> students = new ArrayList<StudentRecord>();
	private int numOfStudents = 0;
	private Professor prof;
	
	public Course(String name, int units){
		this.name = name;
		this.units = units;
	}
	
	public void assign(Professor prof){
		this.prof = prof;
		prof.assignCourse(this);
	}
	
	public void enroll(Student student){
		students.add(new StudentRecord(student));
		numOfStudents ++;
	}
	
	public void grade(){
		for (StudentRecord r: students){
			Scanner input = new Scanner(System.in);
			System.out.println("Give grade for student "+ r.getStudent().getName() +":");
			double grade = input.nextDouble();
			r.assignGrade(grade);
			if (r.pass()){
				r.getStudent().assignUnits(units);
			}
		}
	}
	
	public int getUnits(){
		return units;
	}
	
	public void printInfo(){
		System.out.println(name +":"+units);
		System.out.println("professor:" + prof);
		for (StudentRecord r: students){
			System.out.println(r);
		}
	}
		
}

class Department
{
	public static void main(String[] args)
	{
		Professor[] profs = new Professor[2];
		profs[0] = new Professor("Prof X", 2012);
		profs[1] = new Professor("Prof Y", 2013);
		
		Student[] students = new Student[4];
		students[0] = new Student("alice", 1);
		students[1] = new Student("bob", 2);
		students[2] = new Student("charlie",3);
		students[3] = new Student("david",4);
		
		Course[] courses = new Course[2];
		courses[0] = new Course("oop", 10);
		courses[1] = new Course("intro", 5);
		
		courses[0].assign(profs[0]);
		courses[0].enroll(students[0]);
		courses[0].enroll(students[1]);
		courses[0].enroll(students[3]);
		
		courses[1].assign(profs[1]);
		courses[1].enroll(students[2]);
		courses[1].enroll(students[3]);
		
		courses[0].grade();
		courses[1].grade();
		
		courses[0].printInfo();
		courses[1].printInfo();
	}
}